
package com.ibm.developerworks.java.j2me_tutorial.midp;


import javax.microedition.midlet.MIDlet;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Form;


/**
 * The HelloWorld application simply displays HelloWorld on the screen
 * of an MIDP device. This class extends MIDlet since it is an MIDP
 * application. It also implements CommandListener to handle events.
 */
public class HelloWorld extends MIDlet implements CommandListener
{
   /** A reference to the main form used by this MIDlet. */
   private Form form;

   /**
    * Default constructor - creates a new Form, initialises the
    * controls on it, then displays it.
    */
   public HelloWorld()
   {
      // Create a new form on which to display our text
      form = new Form("Test App");

      // Add the text "Hello World!" to the form
      form.append("Hello World!");

      // Add a command button labeled "Exit"
      form.addCommand( new Command( "Exit", Command.EXIT, 1 ) );

      // Register this object as a commandListener
      form.setCommandListener( this );
   }

   /**
    * The startApp method is invoked to start the application much
    * like an applets start method. It may be called numerous times
    * during a single execution of a MIDlet. If the MIDlet is paused
    * pauseApp will be invoked. To restart the MIDlet, startApp will
    * be called. Main initialization code that only needs to be
    * performed once should be placed in the constructor.
    */
   public void startApp()
   {
      // Get a reference to the display, and show the form
      Display display = Display.getDisplay(this);
      display.setCurrent( form );
   }

   /**
    * pauseApp is invoked to put the MIDlet into a paused state.
    */
   public void pauseApp()
   {
   }

   /**
    * destroyApp is invoked to destroy the MIDlet and put it into a
    * destroyed state.
    */
   public void destroyApp(boolean unconditional)
   {
      form = null;
   }

   /**
    * The commandAction method is the event handler required to support
    * the CommandListener interface. Currently it is destroys the
    * application, and notifies the application management software
    * that it is complete.
    */
   public void commandAction(Command c, Displayable d)
   {
      // Destroy this MIDlet
      destroyApp(true);

      // Notify the application management software that this MIDlet
      // has entered the destroyed state
      notifyDestroyed();
   }
}
